import 'package:flutter/material.dart';
import 'package:gertec_tsg800/config_tsg800/barCode.dart';
import 'package:gertec_tsg800/config_tsg800/configString.dart';
import 'package:gertec_tsg800/gertec_tsg800.dart';

void main() => runApp(MyApp());

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example GPOS800'),
        ),
        body: Center(
          child: Column(
            children: <Widget>[
              RaisedButton(
                child: Text("Imprimir Texto"),
                onPressed: () async {
                  // uso do await, esperar a impressão terminar para chamar a função que finaliza e as restantes
                  await GertecTsg800.imprimirTexto(
                    texto: "GERTEC",
                    alinhamento: Alinhamento.centralizado,
                    fontFamily: TipofontFamily.novaFonte(
                      'assets/fonts/American Dreamer.otf',
                    ),
                  );
                  GertecTsg800.avancarLinha(100);
                  GertecTsg800.finalizarImpressao();
                },
              ),
              RaisedButton(
                child: Text("Imprimir Codigo de Barra"),
                onPressed: () async {
                  // uso do await, esperar a impressão terminar para chamar a função que finaliza e as restantes
                  await GertecTsg800.imprimirCodigoDeBarra(
                      texto: "Gertec", codeType: TipoCodigoImpressao.qrCode);
                  GertecTsg800.avancarLinha(50);
                  GertecTsg800.finalizarImpressao();
                },
              ),
              RaisedButton(
                child: Text("Gravar no Cartão"),
                onPressed: () {
                  GertecTsg800.gravarCartao(mensagemGravar: "GERTEC");
                },
              ),
              RaisedButton(
                child: Text("Ler Cartão"),
                onPressed: () {
                  GertecTsg800.lerCartao;
                },
              ),
              RaisedButton(
                child: Text("Verificar Status"),
                onPressed: () {
                  GertecTsg800.getStatus.then((value) => print(value));
                },
              ),
              RaisedButton(
                child: Text("Ler Codigo de Barra"),
                onPressed: () {
                  GertecTsg800.leitorCodigoDeBarra(
                    tipoLeitura: TipoCodigoLeitura.qrCode,
                  ).then(
                    (onValue) {
                      print("Resultado: " + onValue);
                    },
                  );
                },
              ),
              RaisedButton(
                child: Text("Imprimir Imagem"),
                onPressed: () async {
                  // uso do await, esperar a impressão terminar para chamar a função que finaliza e as restantes
                  // Somente necesserio enviar o asset Path da imagem
                  await GertecTsg800.imprimirImagem(
                    assetPath: "assets/gertec.jpg",
                    width: 500,
                    height: 500,
                  );
                  GertecTsg800.finalizarImpressao();
                },
              ),
            ],
          ),
        ),
      ),
    );
  }
}
